///for calc
const priceUpTo250 = 1.44;
const priceAbove250 = 1.68;
const inputKwattInMonth = document.querySelector('.kwatt');
const inputYear = document.querySelector('.year');
const select = document.querySelector('select');
const form = document.querySelector('.form');
const report = document.querySelector('.report');
const closeBtn = document.querySelector('.btn-close');

//for login
const formLogin = document.querySelector('.form-login');
const inputLogin = document.querySelector('.input-login');
const inputPassword = document.querySelector('.input-password');
const messageResult = document.querySelector('.message');
const close = document.querySelector('.close-btn');


/////////////////////////

const calc = function(){

    function daysInMonth(year, month){                                      //days in selected month
        return 33 - new Date(year, month, 33).getDate();
    }

    function costMonth (value){                                             // money in selected month (2 rate)
        if (value>250){
            return 250 * 1.44 + (value - 250) * 1.68
        } else{
            return value * 1.44
        }
    }

    function showReport (days, cost){
        let costForDay = (cost / days).toFixed(2);
        report.querySelector('div').innerHTML = `В текущем месяце вы потратили ${cost} грн. <br>В день ${costForDay} грн.`;
        report.style.display = 'block'
    }

    form.addEventListener("submit", (e) => {
        e.preventDefault();
        let currYear = inputYear.value;
        let currMonth = select.value;
        let days = daysInMonth(currYear, currMonth);
        
        let cost = costMonth(inputKwattInMonth.value).toFixed(2);
        showReport(days, cost);
    })

    closeBtn.addEventListener("click", (e) => {
        e.preventDefault();
        report.style.display = 'none';
    })
}

/////////////////////////////////////

const login = function(){

    const credentials = {
        login: 'admin',
        password: 'qwerty',
    };

    function success (){
        messageResult.style.display = 'block';
        messageResult.style.backgroundColor = 'green';
        messageResult.querySelector('div').innerHTML = 'success';
        messageResult.querySelector('button').style.backgroundColor = 'green'
    }

    function loginError(){
        messageResult.style.display = 'block';
        messageResult.style.backgroundColor = 'red';
        messageResult.querySelector('div').innerHTML = 'Error';
        messageResult.querySelector('button').style.backgroundColor = 'red'
    }

    formLogin.addEventListener("submit", (e) => {
        e.preventDefault();
        let loginValue = inputLogin.value.trim();
        let passwordValue = inputPassword.value.trim();
        if (loginValue === credentials.login){
            if (passwordValue === credentials.password){
                success();
            } else {
                loginError();
            }
        } else {
            loginError();
        }
    })

    close.addEventListener("click", (e) => {
        e.preventDefault();
        messageResult.style.display = 'none';
    })
    
}


calc();
login();


