////////////////////////////////////////////////////////////////ES6
let a = (str) => alert(str);
// a("Привет!") // вызывает alert("Привет!")

let cube = (num) => num**3;
// alert(cube(5))
//or
let cube2 = (num) => Math.pow(num, 3);
// alert(cube2(4))

let avg2 = (a, b) => (a + b) /2;
// alert(avg2(10,5));


// let sum3 = (a, b, c = 0) => a + b + c; //или
let sum3 = (...arr) => arr.reduce((a,b) => a+b) // но по условию сумма 3 аргументов
// alert(sum3(10, 5, 20));
// alert(sum3(4, 4));


let intRandom = (min, max) => {
    let num = (!max) ? Math.round(Math.random() * min) : Math.round(Math.random() * (max - min)) + min;
        return num
}
// alert(intRandom(3));

let greetAll = (...arrNames) => {
    let greeting = "Hello ";
    arrNames.forEach((person) => {
        greeting += `${person}, `
    })
    alert(greeting);
}
// greetAll("Superman", "SpiderMan", "Captain Obvious", "Vitya");

let sum = (...arr) => arr.reduce((a,b) => a + b);
// console.log(sum (7,56,67,68,2));


///////////////////////////////////////sort

var persons = [
    {name: "Иван", age: 17},
    {name: "Мария", age: 35},
    {name: "Алексей", age: 73},
    {name: "Яков", age: 12},
    {name: "Дима", age: 28},
    {name: "Миша", age: 50},
    {name: "Андрей", age: 60}
]

let sort = (arr, key, reverse = true) => {
    for (let i = 0; i < arr.length-1; i++){
        let wasSwap = false;
        for(let j = 0; j < (arr.length-1)-i; j++){  //// каждый раз уменьшаем количество итераций на i (-i), так как в конце уже все четко
            if(reverse){
                if(arr[j][key] > arr[j + 1][key]){
                    [arr[j], arr[j + 1]] = [arr[j + 1], arr[j]]; ///меняем местами полностью обьекты а не ключи
                    wasSwap = true
                }
            }else{
                if(arr[j][key] < arr[j + 1][key]){
                    [arr[j], arr[j + 1]] = [arr[j + 1], arr[j]];          
                    wasSwap = true
                }
            }
            
        }
        if(!wasSwap) break;
    }
    return arr
}

////////////////////////////////////////array map
let arr = ["1", {}, null, undefined, "500", 700];
let arr2 = arr.map((elem) => {
    if(typeof elem === "string" && !isNaN(+elem)){
        elem = +elem
    }
    return elem
})

console.log(arr2)

/////////////////////////////////////////////array reduce
let arr5 = [4, NaN, 3, Infinity, "0", "34", 5, "string", 6, null];
// let arr6 = arr5.reduce((a, b) => {
//     if(typeof b === 'number' && !isNaN(b * 0)){
        
//         return a * b
//     } else {
//         return a
//     }
    
// }, 1)      
//или 
let arr6 = arr5.reduce((a,b) => (typeof b === 'number' && !isNaN(b*0) ? a * b : a),1);
console.log(arr6);

///////////////////////////////////////object filter
var phone = {
    brand: "meizu",
    model: "m2",
    ram: 2,
    color: "black",
};

function filter(obj, fun){
    let newObj = {};
    Object.entries(obj).forEach((item)=>{
        if (fun(item[0], item[1])){
            newObj[item[0]] = item[1];
        };

    });
    return newObj
}

console.log(filter(phone, (key, value) => value == 'black' || value == 'm2')); /// => {model: 'm2', color: 'black'}
//console.log(filter(phone,(key,value) => key == "color" || value == 2)); //=> {ram: 2, color: 'black'}
//console.log(filter(phone,(key,value) => key == "color" || value == "black")); //=> {color: 'black'} 

///////////////////////////////object map
function map (obj, func){
    let res = {}
    Object.entries(obj).forEach((item) => {
        res = {...res,...func(item[0], item[1])}
    })
    console.log(res)
}

map({name: "Иван", age: 17},(key,value) => {
    let result = {};
    result[key+"_"] = value + "$";
    return result                           
});

//////////////////////////////////////////////////////Sum

const s = n => n <= 1 ? 1 : n + s(n-1);

////////////////////////////////////////////////////HTML Tree
let body = {
    tagName : 'body',
    subTags : [
        {
            tagName : 'div',
            subTags : [
                {
                    tagName : 'span',
                    text : 'Enter a data please:'
                },
                {
                    tagName : 'br'
                },
                {
                    tagName : 'input',
                    attrs : {
                        type : 'text',
                        id : 'name'
                    }
                },
                {
                    tagName : 'hr'
                },
                {
                    tagName : 'input',
                    attrs : {
                        type : 'text',
                        id : 'surname'
                    }
                }
            ]
        },
        {
            tagName : 'div',
            subTags : [
                {
                    tagName : 'button',
                    attrs : {
                        id : 'ok'
                    },
                    text : 'OK'
                },
                {
                    tagName : 'button',
                    attrs : {
                        id : 'cancel'
                    },
                    text : 'Cancel'
                }
            ]
        }
   ]
}
let str4 = '';

function makeHtml(obj, level = 0){
    let tab = '    '.repeat(level);                 ///добавляем tab
    let {tagName, subTags, attrs, text} = obj;

    if(attrs){
        str4 += tab +`<${tagName}`
        for(let key in attrs){
            str4 += ` ${key}=${attrs[key]}`
        }
        str4 += '>'
    } else {
        str4 += tab + `<${tagName}>`
    }

    if(text){
        str4 += text;
        str4 += `</${tagName}>`
        str4 += '\n'

    }

    if(subTags){
        str4 += '\n'
        subTags.forEach((tag) => {
            makeHtml(tag, level + 1);      //рекурсивно вызываем для вложеных элементов
        })
        str4 += tab + `</${tagName}>`
        str4 += '\n'
    }

    if (!text && !subTags){
        str4 += '\n'
    }
}

makeHtml(body);

console.log(str4);








